routes/web.php
<?php

use App\Http\Controllers\DashboardController;
use App\Http\Controllers\InvitationController;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\LogoutController;
use App\Http\Controllers\MessageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::middleware(['auth'])->group(function () {
    # dashboard
    Route::get('/dashboard', DashboardController::class)->name('apps.dashboard.index');
    # messages
    Route::post('/messages', [MessageController::class, 'store'])->name('apps.message.store');
    # logout
    Route::post('/logout', LogoutController::class)->name('logout')->middleware(['auth']);
});

# invitations
Route::resource('/invitations', InvitationController::class, ['as' => 'apps']);

Route::middleware(['guest'])->group(function () {
    # login
    Route::get('/login', [LoginController::class, 'showLogin'])->name('login');
    Route::post('/login', [LoginController::class, 'loginUser'])->name('login');
});

app/Models/Invitation.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Invitation extends Model
{
    use HasFactory;

    # guarded
    protected $guarded = [];

    # relation table
    public function bride()
    {
        return $this->belongsTo(Bride::class);
    }

    public function messages()
    {
        return $this->hasMany(Message::class);
    }

    # route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }
}

app/Http/Controllers/InvitationController.php
<?php

namespace App\Http\Controllers;

use App\Models\Bride;
use App\Models\Invitation;
use App\Models\Message;
use Illuminate\Http\Request;

class InvitationController extends Controller
{
    # __construct for middleware
    public function __construct()
    {
        $this->middleware(['auth'])->except(['show']);
    }

    # get all data invitations
    public function index(Invitation $invitation)
    {
        # get all data invitations
        $invitations = Invitation::query()->when(request()->q, function($invitations) {
            $invitations->where('name', 'like', '%' . request()->q . '%')
            ->orWhereRelation('bride', 'name', 'like', '%' . request()->q . '%');
        })->latest()->paginate(25);

        # return view
        return view('apps.invitations.index', compact('invitations', 'invitation'));
    }

    # view create invitation
    public function create(Invitation $invitation)
    {
        # get all data bride
        $brides = Bride::all();

        # return view
        return view('apps.invitations.create', compact('brides'));
    }

    # action create invitation
    public function store(Request $request)
    {
        # validation
        $request->validate([
            'name' => ['required'],
            'bride_id' => ['required'],
            'status' => ['required'],
        ]);

        # create invitation
        Invitation::create([
            'name' => $request->name,
            'slug' => str($request->name . ' ' . str()->random(7))->slug(),
            'bride_id' => $request->bride_id,
            'status' => $request->status,
        ]);

        # redirect
        return to_route('apps.invitations.index');
    }

    # view invited guest
    public function show(Invitation $invitation, Message $message)
    {
        # show message by guest
        $messages = $invitation->messages()->get();

        # return view
        return view('apps.invitations.show', compact('invitation', 'messages', 'message'));
    }

    # view edit invitation
    public function edit(Invitation $invitation)
    {
        # get all data bride
        $brides = Bride::all();

        # return view
        return view('apps.invitations.edit', compact('brides', 'invitation'));
    }

    # action update invitation
    public function update(Request $request, Invitation $invitation)
    {
        # validation
        $request->validate([
            'name' => ['required'],
            'bride_id' => ['required'],
            'status' => ['required'],
        ]);

        # update invitation
        $invitation->update([
            'name' => $request->name,
            'bride_id' => $request->bride_id,
            'status' => $request->status,
        ]);

        # redirect
        return to_route('apps.invitations.index');
    }

    # action delete invitation
    public function destroy(Invitation $invitation)
    {
        # delete invitation
        $invitation->delete();

        # redirect
        return back();
    }
}

resources/views/apps/invitations/create.blade.php
@extends('apps.layouts.app')
@section('content')
  <div class="col-12 mb-4">
    <div class="card adow h-100">
      <div class="card-body">
        <h4 class="fw-bold mb-4">Tambah Tamu Undangan</h4>
        {{-- form create invitation --}}
        <form action="{{ route('apps.invitations.store') }}" method="POST">
          @csrf
          {{-- name --}}
          <div class="mb-3">
            <label for="name" class="form-label">Nama Tamu Undangan</label>
            <input type="text" name="name" class="form-control" id="name">
          </div>
          {{-- invitation from --}}
          <div class="mb-3">
            <label for="bride_Id" class="form-label">Tamu Undangan Dari</label>
            <select name="bride_id" id="bride_Id" class="form-control" id="bride_id">
              @foreach ($brides as $bride)
                <option value="{{ $bride->id }}">{{ $bride->name }}</option>
              @endforeach
            </select>
          </div>
          {{-- status --}}
          <div class="mb-3">
            <label for="status" class="form-label">Status</label>
            <input type="text" name="status" class="form-control" id="status">
          </div>
          {{-- button submit --}}
          <button type="submit" class="btn btn-primary">Create</button>
        </form>
      </div>
    </div>
  </div>
@endsection

resources/views/apps/invitations/edit.blade.php
@extends('apps.layouts.app')
@section('content')
  <div class="col-12 mb-4">
    <div class="card adow h-100 py-2">
      <div class="card-body">
        <h4 class="fw-bold mb-4">Edit Tamu Undangan</h4>
        {{-- form edit invitation --}}
        <form action="{{ route('apps.invitations.update', $invitation) }}" method="POST">
          @csrf
          @method('put')
          {{-- name --}}
          <div class="mb-3">
            <label for="name" class="form-label">Nama Tamu Undangan</label>
            <input type="text" name="name" class="form-control" id="name"
              value="{{ old('name', $invitation->name) }}">
          </div>
          {{-- invitations from --}}
          <div class="mb-3">
            <label for="bride_Id" class="form-label">Tamu Undangan Dari</label>
            <select name="bride_id" id="bride_Id" class="form-control" id="bride_id">
              @foreach ($brides as $bride)
                <option {{ old('bride') == $bride->id || $invitation?->bride_id == $bride->id ? 'selected' : '' }}
                  value="{{ $bride->id }}">{{ $bride->name }}</option>
              @endforeach
            </select>
          </div>
          {{-- status --}}
          <div class="mb-3">
            <label for="status" class="form-label">Status</label>
            <input type="text" name="status" class="form-control" id="status"
              value="{{ old('status', $invitation->status) }}">
          </div>
          {{-- button submit --}}
          <button type="submit" class="btn btn-primary">Update</button>
        </form>
      </div>
    </div>
  </div>
@endsection

resources/views/apps/invitations/index.blade.php
@extends('apps.layouts.app')
@section('content')
  <div class="col-12 col-md-12 mb-4">
    <div class="card adow h-100 py-2">
      <div class="card-body">
        <div class="row no-gutters align-items-center">
          <div class="col-12 col-sm-4 col-md-4 mb-3 mb-sm-0">
            <a href="{{ route('apps.invitations.create') }}" class="btn btn-primary">Tambah Tamu </a>
          </div>
          <div class="col-12 col-sm-8 col-xl-8">
            <form action="{{ route('apps.invitations.index') }}">
              <div class="input-group">
                <input type="search" class="form-control" name="q" placeholder="Cari Tamu Undangan">
                <div class="input-group-append">
                  <button type="submit" class="btn btn-primary">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
          <div class="table-responsive mt-2">
            <table class="table table-hovered">
              <thead>
                <tr>
                  <th>#</th>
                  <th>Nama Tamu Undangan</th>
                  <th>Tamu Undangan Dari</th>
                  <th>Status</th>
                  <th>Actions</th>
                </tr>
              </thead>
              <tbody>
                @forelse ($invitations as $invitation)
                  <tr>
                    <td>{{ $invitations->firstItem() + $loop->index }}</td>
                    <td>
                      <a href="{{ route('apps.invitations.show', $invitation) }}" target="_blank">
                        {{ $invitation->name }}
                      </a>
                    </td>
                    <td>{{ $invitation->bride->name }}</td>
                    <td><span class="badge bg-info text-white">{{ $invitation->status }}</span></td>
                    <td>
                      <a href="{{ route('apps.invitations.edit', $invitation) }}"
                        class="btn btn-sm btn-warning mb-2 mb-md-0">
                        <i class="fa fa-pencil-alt"></i>
                      </a>
                      <button onclick="Delete(this.id)" class="btn btn-sm btn-danger" id="{{ $invitation->slug }}">
                        <i class="fa fa-trash"></i>
                        </butt>
                    </td>
                  </tr>
                @empty
                  <tr>
                    <td colspan="4" class="text-center text-danger">Tidak ada data tamu</td>
                  </tr>
                @endforelse
              </tbody>
            </table>
          </div>
        </div>
        {{-- pagination --}}
        {{ $invitations->links() }}
      </div>
    </div>
  </div>

  <script>
    // ajax delete
    function Delete(id) {
      var id = id;
      var token = $("meta[name='csrf-token']").attr("content");

      Swal.fire({
        title: "Ingin menghapus data ini?",
        text: "Data yang sudah dihapus tidak dapat dikembalikan lagi!",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      }).then((result) => {
        if (result.isConfirmed) {
          jQuery.ajax({
            url: "/invitations/" + id,
            data: {
              "id": id,
              "_token": token
            },
            type: "DELETE"
          });
          Swal.fire({
            position: 'center',
            icon: 'success',
            title: 'Data tamu berhasil di hapus',
            showConfirmButton: false,
            timer: 1500,
          }).then(function() {
            location.reload();
          });
        }
      });
    }
  </script>
@endsection

resources/views/apps/invitations/show.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
  @include('apps.invitations.partials.show.head')
</head>

<body>
  <!-- audio backsound -->
  {{-- <audio src="{{ asset('assets/audio/backsound.mp3') }}" id="myaudio" class="d-none" preload="auto" controls loop autoplay></audio> --}}

  {{-- wedding modal --}}
  @include('apps.invitations.partials.show.wedding-modal')

  {{-- hero --}}
  @include('apps.invitations.partials.show.hero')

  <main id="main">
    {{-- bride --}}
    @include('apps.invitations.partials.show.bride')

    {{-- ceremony reception --}}
    @include('apps.invitations.partials.show.ceremony-reception')

    {{-- reception location  --}}
    @include('apps.invitations.partials.show.reception-location')

    {{-- memoreable moments --}}
    @include('apps.invitations.partials.show.memoreable')

    {{-- count down & message --}}
    @include('apps.invitations.partials.show.count-down-message')

    {{-- amplop --}}
    @include('apps.invitations.partials.show.amplop')
    
    {{-- prayer --}}
    @include('apps.invitations.partials.show.prayer')

    {{-- closing --}}
    @include('apps.invitations.partials.show.closing')
  </main>

  {{-- footer --}}
  @include('apps.invitations.partials.show.footer')
  {{-- javascript --}}
  @include('apps.invitations.partials.show.js')

  {{-- javascript stack --}}
  @stack('scripts')
</body>

</html>